/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.128 Revision 1.150
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.128 2011/08/19 10:10:03 lxnay Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.150 2012/02/13 23:50:12 zmedico Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Gentoo Python Project <python@gentoo.org> 7# Gentoo Python Project <python@gentoo.org>
8# @BLURB: Eclass for Python packages 8# @BLURB: Eclass for Python packages
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The python eclass contains miscellaneous, useful functions for Python packages. 10# The python eclass contains miscellaneous, useful functions for Python packages.
11 11
12# Must call inherit before EXPORT_FUNCTIONS to avoid QA warning.
13if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
12inherit multilib 14 inherit multilib
15fi
13 16
17# Export pkg_setup every time to avoid issues with eclass inheritance order.
18if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
19 EXPORT_FUNCTIONS pkg_setup
20fi
21
22# Avoid processing this eclass more than once.
23if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
24_PYTHON_ECLASS_INHERITED="1"
25
14if ! has "${EAPI:-0}" 0 1 2 3; then 26if ! has "${EAPI:-0}" 0 1 2 3 4; then
15 die "API of python.eclass in EAPI=\"${EAPI}\" not established" 27 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
16fi 28fi
17 29
18_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7) 30_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7)
19_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.1 3.2 3.3) 31_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.1 3.2)
20_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython) 32_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython)
21_PYPY_GLOBALLY_SUPPORTED_ABIS=(2.7-pypy-1.5) 33_PYPY_GLOBALLY_SUPPORTED_ABIS=(2.7-pypy-1.7 2.7-pypy-1.8)
22_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]} ${_PYPY_GLOBALLY_SUPPORTED_ABIS[@]}) 34_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]} ${_PYPY_GLOBALLY_SUPPORTED_ABIS[@]})
23 35
24# ================================================================================================ 36# ================================================================================================
25# ===================================== HANDLING OF METADATA ===================================== 37# ===================================== HANDLING OF METADATA =====================================
26# ================================================================================================ 38# ================================================================================================
384 _CYAN= 396 _CYAN=
385 _NORMAL= 397 _NORMAL=
386 fi 398 fi
387} 399}
388 400
389unset PYTHON_PKG_SETUP_EXECUTED
390
391_python_check_python_pkg_setup_execution() { 401_python_check_python_pkg_setup_execution() {
392 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return 402 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return
393 403
394 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then 404 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then
395 die "python_pkg_setup() not called" 405 die "python_pkg_setup() not called"
398 408
399# @FUNCTION: python_pkg_setup 409# @FUNCTION: python_pkg_setup
400# @DESCRIPTION: 410# @DESCRIPTION:
401# Perform sanity checks and initialize environment. 411# Perform sanity checks and initialize environment.
402# 412#
403# This function is exported in EAPI 2 and 3. Calling of this function is mandatory in EAPI >=4. 413# This function is exported in EAPI 2 and 3 when PYTHON_USE_WITH or PYTHON_USE_WITH_OR variable
414# is set and always in EAPI >=4. Calling of this function is mandatory in EAPI >=4.
404python_pkg_setup() { 415python_pkg_setup() {
405 if [[ "${EBUILD_PHASE}" != "setup" ]]; then 416 if [[ "${EBUILD_PHASE}" != "setup" ]]; then
406 die "${FUNCNAME}() can be used only in pkg_setup() phase" 417 die "${FUNCNAME}() can be used only in pkg_setup() phase"
407 fi 418 fi
408 419
418 export EPYTHON="$(PYTHON -f)" 429 export EPYTHON="$(PYTHON -f)"
419 else 430 else
420 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}" 431 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
421 fi 432 fi
422 433
434 if ! has "${EAPI:-0}" 0 1 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; then
435 if [[ "${PYTHON_USE_WITH_OPT}" ]]; then
436 if [[ "${PYTHON_USE_WITH_OPT}" == !* ]]; then
437 use ${PYTHON_USE_WITH_OPT#!} && return
438 else
439 use !${PYTHON_USE_WITH_OPT} && return
440 fi
441 fi
442
443 python_pkg_setup_check_USE_flags() {
444 local python_atom USE_flag
445 python_atom="$(python_get_implementational_package)"
446
447 for USE_flag in ${PYTHON_USE_WITH}; do
448 if ! has_version "${python_atom}[${USE_flag}]"; then
449 eerror "Please rebuild ${python_atom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
450 die "Please rebuild ${python_atom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
451 fi
452 done
453
454 for USE_flag in ${PYTHON_USE_WITH_OR}; do
455 if has_version "${python_atom}[${USE_flag}]"; then
456 return
457 fi
458 done
459
460 if [[ ${PYTHON_USE_WITH_OR} ]]; then
461 eerror "Please rebuild ${python_atom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
462 die "Please rebuild ${python_atom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
463 fi
464 }
465
466 if _python_package_supporting_installation_for_multiple_python_abis; then
467 PYTHON_SKIP_SANITY_CHECKS="1" python_execute_function -q python_pkg_setup_check_USE_flags
468 else
469 python_pkg_setup_check_USE_flags
470 fi
471
472 unset -f python_pkg_setup_check_USE_flags
473 fi
474
423 PYTHON_PKG_SETUP_EXECUTED="1" 475 PYTHON_PKG_SETUP_EXECUTED="1"
424} 476}
425
426if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
427 EXPORT_FUNCTIONS pkg_setup
428fi
429 477
430_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|pypy-c|python)' 478_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|pypy-c|python)'
431 479
432# @FUNCTION: python_convert_shebangs 480# @FUNCTION: python_convert_shebangs
433# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories] 481# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories]
434# @DESCRIPTION: 482# @DESCRIPTION:
435# Convert shebangs in specified files. Directories can be specified only with --recursive option. 483# Convert shebangs in specified files. Directories can be specified only with --recursive option.
436python_convert_shebangs() { 484python_convert_shebangs() {
437 _python_check_python_pkg_setup_execution 485 _python_check_python_pkg_setup_execution
438 486
439 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0" 487 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0" shebangs_converted="0"
440 488
441 while (($#)); do 489 while (($#)); do
442 case "$1" in 490 case "$1" in
443 -r|--recursive) 491 -r|--recursive)
444 recursive="1" 492 recursive="1"
499 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue 547 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
500 548
501 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then 549 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then
502 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue 550 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
503 551
552 shebangs_converted="1"
553
504 if [[ "${quiet}" == "0" ]]; then 554 if [[ "${quiet}" == "0" ]]; then
505 einfo "Converting shebang in '${file}'" 555 einfo "Converting shebang in '${file}'"
506 fi 556 fi
507 557
508 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|pypy-c\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed" 558 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|pypy-c\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed"
509 fi 559 fi
560 done
561
562 if [[ "${shebangs_converted}" == "0" ]]; then
563 ewarn "${FUNCNAME}(): Python scripts not found"
564 fi
565}
566
567# @FUNCTION: python_clean_py-compile_files
568# @USAGE: [-q|--quiet]
569# @DESCRIPTION:
570# Clean py-compile files to disable byte-compilation.
571python_clean_py-compile_files() {
572 _python_check_python_pkg_setup_execution
573
574 local file files=() quiet="0"
575
576 while (($#)); do
577 case "$1" in
578 -q|--quiet)
579 quiet="1"
580 ;;
581 -*)
582 die "${FUNCNAME}(): Unrecognized option '$1'"
583 ;;
584 *)
585 die "${FUNCNAME}(): Invalid usage"
586 ;;
587 esac
588 shift
589 done
590
591 while read -d $'\0' -r file; do
592 files+=("${file#./}")
593 done < <(find -name py-compile -type f -print0)
594
595 for file in "${files[@]}"; do
596 if [[ "${quiet}" == "0" ]]; then
597 einfo "Cleaning '${file}' file"
598 fi
599 echo "#!/bin/sh" > "${file}"
510 done 600 done
511} 601}
512 602
513# @FUNCTION: python_clean_installation_image 603# @FUNCTION: python_clean_installation_image
514# @USAGE: [-q|--quiet] 604# @USAGE: [-q|--quiet]
1189import os 1279import os
1190import re 1280import re
1191import subprocess 1281import subprocess
1192import sys 1282import sys
1193 1283
1194cpython_re = re.compile(r"^python(\d+\.\d+)$") 1284cpython_ABI_re = re.compile(r"^(\d+\.\d+)$")
1285jython_ABI_re = re.compile(r"^(\d+\.\d+)-jython$")
1286pypy_ABI_re = re.compile(r"^\d+\.\d+-pypy-(\d+\.\d+)$")
1287cpython_interpreter_re = re.compile(r"^python(\d+\.\d+)$")
1195jython_re = re.compile(r"^jython(\d+\.\d+)$") 1288jython_interpreter_re = re.compile(r"^jython(\d+\.\d+)$")
1196pypy_re = re.compile(r"^pypy-c(\d+\.\d+)$") 1289pypy_interpreter_re = re.compile(r"^pypy-c(\d+\.\d+)$")
1197python_shebang_re = re.compile(r"^#! *(${EPREFIX}/usr/bin/python|(${EPREFIX})?/usr/bin/env +(${EPREFIX}/usr/bin/)?python)") 1290cpython_shebang_re = re.compile(r"^#![ \t]*(?:${EPREFIX}/usr/bin/python|(?:${EPREFIX})?/usr/bin/env[ \t]+(?:${EPREFIX}/usr/bin/)?python)")
1291python_shebang_options_re = re.compile(r"^#![ \t]*${EPREFIX}/usr/bin/(?:jython|pypy-c|python)(?:\d+(?:\.\d+)?)?[ \t]+(-\S)")
1198python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$") 1292python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$")
1199 1293
1200pypy_versions_mapping = { 1294pypy_versions_mapping = {
1201 "1.5": "2.7" 1295 "1.5": "2.7"
1202} 1296}
1203 1297
1204def get_PYTHON_ABI(EPYTHON): 1298def get_PYTHON_ABI(python_interpreter):
1205 cpython_matched = cpython_re.match(EPYTHON) 1299 cpython_matched = cpython_interpreter_re.match(python_interpreter)
1206 jython_matched = jython_re.match(EPYTHON) 1300 jython_matched = jython_interpreter_re.match(python_interpreter)
1207 pypy_matched = pypy_re.match(EPYTHON) 1301 pypy_matched = pypy_interpreter_re.match(python_interpreter)
1208 if cpython_matched is not None: 1302 if cpython_matched is not None:
1209 PYTHON_ABI = cpython_matched.group(1) 1303 PYTHON_ABI = cpython_matched.group(1)
1210 elif jython_matched is not None: 1304 elif jython_matched is not None:
1211 PYTHON_ABI = jython_matched.group(1) + "-jython" 1305 PYTHON_ABI = jython_matched.group(1) + "-jython"
1212 elif pypy_matched is not None: 1306 elif pypy_matched is not None:
1213 PYTHON_ABI = pypy_versions_mapping[pypy_matched.group(1)] + "-pypy-" + pypy_matched.group(1) 1307 PYTHON_ABI = pypy_versions_mapping[pypy_matched.group(1)] + "-pypy-" + pypy_matched.group(1)
1214 else: 1308 else:
1215 PYTHON_ABI = None 1309 PYTHON_ABI = None
1216 return PYTHON_ABI 1310 return PYTHON_ABI
1217 1311
1312def get_python_interpreter(PYTHON_ABI):
1313 cpython_matched = cpython_ABI_re.match(PYTHON_ABI)
1314 jython_matched = jython_ABI_re.match(PYTHON_ABI)
1315 pypy_matched = pypy_ABI_re.match(PYTHON_ABI)
1316 if cpython_matched is not None:
1317 python_interpreter = "python" + cpython_matched.group(1)
1318 elif jython_matched is not None:
1319 python_interpreter = "jython" + jython_matched.group(1)
1320 elif pypy_matched is not None:
1321 python_interpreter = "pypy-c" + pypy_matched.group(1)
1322 else:
1323 python_interpreter = None
1324 return python_interpreter
1325
1218EOF 1326EOF
1219 if [[ "$?" != "0" ]]; then 1327 if [[ "$?" != "0" ]]; then
1220 die "${FUNCNAME}(): Generation of '$1' failed" 1328 die "${FUNCNAME}(): Generation of '$1' failed"
1221 fi 1329 fi
1222 if [[ "${respect_EPYTHON}" == "1" ]]; then 1330 if [[ "${respect_EPYTHON}" == "1" ]]; then
1223 cat << EOF >> "${file}" 1331 cat << EOF >> "${file}"
1224EPYTHON = os.environ.get("EPYTHON") 1332python_interpreter = os.environ.get("EPYTHON")
1225if EPYTHON: 1333if python_interpreter:
1226 PYTHON_ABI = get_PYTHON_ABI(EPYTHON) 1334 PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1227 if PYTHON_ABI is None: 1335 if PYTHON_ABI is None:
1228 sys.stderr.write("%s: EPYTHON variable has unrecognized value '%s'\n" % (sys.argv[0], EPYTHON)) 1336 sys.stderr.write("%s: EPYTHON variable has unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1229 sys.exit(1) 1337 sys.exit(1)
1230else: 1338else:
1231 try: 1339 try:
1232 environment = os.environ.copy() 1340 environment = os.environ.copy()
1233 environment["ROOT"] = "/" 1341 environment["ROOT"] = "/"
1236 raise ValueError 1344 raise ValueError
1237 except (OSError, ValueError): 1345 except (OSError, ValueError):
1238 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0]) 1346 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1239 sys.exit(1) 1347 sys.exit(1)
1240 1348
1241 EPYTHON = eselect_process.stdout.read() 1349 python_interpreter = eselect_process.stdout.read()
1242 if not isinstance(EPYTHON, str): 1350 if not isinstance(python_interpreter, str):
1243 # Python 3 1351 # Python 3
1244 EPYTHON = EPYTHON.decode() 1352 python_interpreter = python_interpreter.decode()
1245 EPYTHON = EPYTHON.rstrip("\n") 1353 python_interpreter = python_interpreter.rstrip("\n")
1246 1354
1247 PYTHON_ABI = get_PYTHON_ABI(EPYTHON) 1355 PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1248 if PYTHON_ABI is None: 1356 if PYTHON_ABI is None:
1249 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], EPYTHON)) 1357 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1250 sys.exit(1) 1358 sys.exit(1)
1251 1359
1252wrapper_script_path = os.path.realpath(sys.argv[0]) 1360wrapper_script_path = os.path.realpath(sys.argv[0])
1253target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI) 1361target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1254if not os.path.exists(target_executable_path): 1362if not os.path.exists(target_executable_path):
1268 raise ValueError 1376 raise ValueError
1269except (OSError, ValueError): 1377except (OSError, ValueError):
1270 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0]) 1378 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1271 sys.exit(1) 1379 sys.exit(1)
1272 1380
1273EPYTHON = eselect_process.stdout.read() 1381python_interpreter = eselect_process.stdout.read()
1274if not isinstance(EPYTHON, str): 1382if not isinstance(python_interpreter, str):
1275 # Python 3 1383 # Python 3
1276 EPYTHON = EPYTHON.decode() 1384 python_interpreter = python_interpreter.decode()
1277EPYTHON = EPYTHON.rstrip("\n") 1385python_interpreter = python_interpreter.rstrip("\n")
1278 1386
1279PYTHON_ABI = get_PYTHON_ABI(EPYTHON) 1387PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1280if PYTHON_ABI is None: 1388if PYTHON_ABI is None:
1281 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], EPYTHON)) 1389 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1282 sys.exit(1) 1390 sys.exit(1)
1283 1391
1284wrapper_script_path = os.path.realpath(sys.argv[0]) 1392wrapper_script_path = os.path.realpath(sys.argv[0])
1285for PYTHON_ABI in [PYTHON_ABI, ${PYTHON_ABIS_list}]: 1393for PYTHON_ABI in [PYTHON_ABI, ${PYTHON_ABIS_list}]:
1286 target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI) 1394 target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1287 if os.path.exists(target_executable_path): 1395 if os.path.exists(target_executable_path):
1288 break 1396 break
1289else: 1397else:
1290 sys.stderr.write("%s: No target script exists for '%s'\n" % (sys.argv[0], wrapper_script_path)) 1398 sys.stderr.write("%s: No target script exists for '%s'\n" % (sys.argv[0], wrapper_script_path))
1291 sys.exit(1) 1399 sys.exit(1)
1400
1401python_interpreter = get_python_interpreter(PYTHON_ABI)
1402if python_interpreter is None:
1403 sys.stderr.write("%s: Unrecognized Python ABI '%s'\n" % (sys.argv[0], PYTHON_ABI))
1404 sys.exit(1)
1292EOF 1405EOF
1293 if [[ "$?" != "0" ]]; then 1406 if [[ "$?" != "0" ]]; then
1294 die "${FUNCNAME}(): Generation of '$1' failed" 1407 die "${FUNCNAME}(): Generation of '$1' failed"
1295 fi 1408 fi
1296 fi 1409 fi
1297 cat << EOF >> "${file}" 1410 cat << EOF >> "${file}"
1298 1411
1299target_executable = open(target_executable_path, "rb") 1412target_executable = open(target_executable_path, "rb")
1300target_executable_first_line = target_executable.readline() 1413target_executable_first_line = target_executable.readline()
1414target_executable.close()
1301if not isinstance(target_executable_first_line, str): 1415if not isinstance(target_executable_first_line, str):
1302 # Python 3 1416 # Python 3
1303 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace") 1417 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace")
1304 1418
1419options = []
1420python_shebang_options_matched = python_shebang_options_re.match(target_executable_first_line)
1421if python_shebang_options_matched is not None:
1422 options = [python_shebang_options_matched.group(1)]
1423
1305python_shebang_matched = python_shebang_re.match(target_executable_first_line) 1424cpython_shebang_matched = cpython_shebang_re.match(target_executable_first_line)
1306target_executable.close()
1307 1425
1308if python_shebang_matched is not None: 1426if cpython_shebang_matched is not None:
1309 try: 1427 try:
1310 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % EPYTHON 1428 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % python_interpreter
1311 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1" 1429 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1"
1312 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE) 1430 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE)
1313 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] 1431 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"]
1314 if python_verification_process.wait() != 0: 1432 if python_verification_process.wait() != 0:
1315 raise ValueError 1433 raise ValueError
1320 python_verification_output = python_verification_output.decode() 1438 python_verification_output = python_verification_output.decode()
1321 1439
1322 if not python_verification_output_re.match(python_verification_output): 1440 if not python_verification_output_re.match(python_verification_output):
1323 raise ValueError 1441 raise ValueError
1324 1442
1325 if cpython_re.match(EPYTHON) is not None: 1443 if cpython_interpreter_re.match(python_interpreter) is not None:
1326 os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0]) 1444 os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0])
1327 os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0] 1445 os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
1328 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path 1446 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
1329 1447
1330 if hasattr(os, "execv"): 1448 if hasattr(os, "execv"):
1331 os.execv(python_interpreter_path, [python_interpreter_path] + sys.argv) 1449 os.execv(python_interpreter_path, [python_interpreter_path] + options + sys.argv)
1332 else: 1450 else:
1333 sys.exit(subprocess.Popen([python_interpreter_path] + sys.argv).wait()) 1451 sys.exit(subprocess.Popen([python_interpreter_path] + options + sys.argv).wait())
1334 except (KeyboardInterrupt, SystemExit): 1452 except (KeyboardInterrupt, SystemExit):
1335 raise 1453 raise
1336 except: 1454 except:
1337 pass 1455 pass
1338 for variable in ("GENTOO_PYTHON_PROCESS_NAME", "GENTOO_PYTHON_WRAPPER_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"): 1456 for variable in ("GENTOO_PYTHON_PROCESS_NAME", "GENTOO_PYTHON_WRAPPER_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"):
1522 fi 1640 fi
1523 done 1641 done
1524 1642
1525 popd > /dev/null || die "popd failed" 1643 popd > /dev/null || die "popd failed"
1526 1644
1645 # This is per bug #390691, without the duplication refactor, and with
1646 # the 3-way structure per comment #6. This enable users with old
1647 # coreutils to upgrade a lot easier (you need to upgrade python+portage
1648 # before coreutils can be upgraded).
1649 if ROOT="/" has_version '>=sys-apps/coreutils-6.9.90'; then
1650 cp -fr --preserve=all --no-preserve=context "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1527 if ROOT="/" has_version sys-apps/coreutils; then 1651 elif ROOT="/" has_version sys-apps/coreutils; then
1528 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed" 1652 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1529 else 1653 else
1530 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed" 1654 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1531 fi 1655 fi
1532 done 1656 done
1551 stdout = sys.stdout.buffer 1675 stdout = sys.stdout.buffer
1552else: 1676else:
1553 # Python 2 1677 # Python 2
1554 stdout = sys.stdout 1678 stdout = sys.stdout
1555 1679
1680python_wrapper_scripts_file = open('${T}/python_wrapper_scripts', 'rb')
1556files = set(open('${T}/python_wrapper_scripts', 'rb').read().rstrip(${b}'\x00').split(${b}'\x00')) 1681files = set(python_wrapper_scripts_file.read().rstrip(${b}'\x00').split(${b}'\x00'))
1682python_wrapper_scripts_file.close()
1557 1683
1558for file in sorted(files): 1684for file in sorted(files):
1559 stdout.write(file) 1685 stdout.write(file)
1560 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of set of wrapper scripts") 1686 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of set of wrapper scripts")
1561 1687
1626 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable. 1752 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable.
1627 PYTHON_REQUESTED_ACTIVE_VERSION="$1" 1753 PYTHON_REQUESTED_ACTIVE_VERSION="$1"
1628} 1754}
1629 1755
1630# @FUNCTION: python_need_rebuild 1756# @FUNCTION: python_need_rebuild
1757# @DESCRIPTION:
1631# @DESCRIPTION: Mark current package for rebuilding by python-updater after 1758# Mark current package for rebuilding by python-updater after
1632# switching of active version of Python. 1759# switching of active version of Python.
1633python_need_rebuild() { 1760python_need_rebuild() {
1634 if _python_package_supporting_installation_for_multiple_python_abis; then 1761 if _python_package_supporting_installation_for_multiple_python_abis; then
1635 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs" 1762 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1636 fi 1763 fi
2335_python_test_hook() { 2462_python_test_hook() {
2336 if [[ "$#" -ne 1 ]]; then 2463 if [[ "$#" -ne 1 ]]; then
2337 die "${FUNCNAME}() requires 1 argument" 2464 die "${FUNCNAME}() requires 1 argument"
2338 fi 2465 fi
2339 2466
2340 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${FUNCNAME[3]}_$1_hook")" == "function" ]]; then 2467 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${_PYTHON_TEST_FUNCTION}_$1_hook")" == "function" ]]; then
2341 "${FUNCNAME[3]}_$1_hook" 2468 "${_PYTHON_TEST_FUNCTION}_$1_hook"
2342 fi 2469 fi
2343} 2470}
2344 2471
2345# @FUNCTION: python_execute_nosetests 2472# @FUNCTION: python_execute_nosetests
2346# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments] 2473# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
2380 python_test_function() { 2507 python_test_function() {
2381 local evaluated_PYTHONPATH 2508 local evaluated_PYTHONPATH
2382 2509
2383 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2510 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2384 2511
2385 _python_test_hook pre 2512 _PYTHON_TEST_FUNCTION="python_execute_nosetests" _python_test_hook pre
2386 2513
2387 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2514 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2388 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL} 2515 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
2389 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?" 2516 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
2390 else 2517 else
2391 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL} 2518 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
2392 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?" 2519 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
2393 fi 2520 fi
2394 2521
2395 _python_test_hook post 2522 _PYTHON_TEST_FUNCTION="python_execute_nosetests" _python_test_hook post
2396 } 2523 }
2397 if _python_package_supporting_installation_for_multiple_python_abis; then 2524 if _python_package_supporting_installation_for_multiple_python_abis; then
2398 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2525 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2399 else 2526 else
2400 if [[ -n "${separate_build_dirs}" ]]; then 2527 if [[ -n "${separate_build_dirs}" ]]; then
2444 python_test_function() { 2571 python_test_function() {
2445 local evaluated_PYTHONPATH 2572 local evaluated_PYTHONPATH
2446 2573
2447 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2574 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2448 2575
2449 _python_test_hook pre 2576 _PYTHON_TEST_FUNCTION="python_execute_py.test" _python_test_hook pre
2450 2577
2451 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2578 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2452 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL} 2579 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL}
2453 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?" 2580 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?"
2454 else 2581 else
2455 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL} 2582 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL}
2456 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?" 2583 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?"
2457 fi 2584 fi
2458 2585
2459 _python_test_hook post 2586 _PYTHON_TEST_FUNCTION="python_execute_py.test" _python_test_hook post
2460 } 2587 }
2461 if _python_package_supporting_installation_for_multiple_python_abis; then 2588 if _python_package_supporting_installation_for_multiple_python_abis; then
2462 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2589 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2463 else 2590 else
2464 if [[ -n "${separate_build_dirs}" ]]; then 2591 if [[ -n "${separate_build_dirs}" ]]; then
2508 python_test_function() { 2635 python_test_function() {
2509 local evaluated_PYTHONPATH 2636 local evaluated_PYTHONPATH
2510 2637
2511 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2638 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2512 2639
2513 _python_test_hook pre 2640 _PYTHON_TEST_FUNCTION="python_execute_trial" _python_test_hook pre
2514 2641
2515 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2642 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2516 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL} 2643 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
2517 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?" 2644 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
2518 else 2645 else
2519 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL} 2646 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
2520 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?" 2647 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
2521 fi 2648 fi
2522 2649
2523 _python_test_hook post 2650 _PYTHON_TEST_FUNCTION="python_execute_trial" _python_test_hook post
2524 } 2651 }
2525 if _python_package_supporting_installation_for_multiple_python_abis; then 2652 if _python_package_supporting_installation_for_multiple_python_abis; then
2526 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2653 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2527 else 2654 else
2528 if [[ -n "${separate_build_dirs}" ]]; then 2655 if [[ -n "${separate_build_dirs}" ]]; then
2787 done 2914 done
2788 for dir in "${evaluated_dirs[@]}"; do 2915 for dir in "${evaluated_dirs[@]}"; do
2789 eval "dirs+=(\"\${root}${dir}\")" 2916 eval "dirs+=(\"\${root}${dir}\")"
2790 done 2917 done
2791 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m compileall "${options[@]}" "${dirs[@]}" 2>&1)" || return_code="1" 2918 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m compileall "${options[@]}" "${dirs[@]}" 2>&1)" || return_code="1"
2792 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2919 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2793 "$(PYTHON)" -O -m compileall "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1" 2920 "$(PYTHON)" -O -m compileall "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1"
2794 fi 2921 fi
2795 _python_clean_compiled_modules "${dirs[@]}" 2922 _python_clean_compiled_modules "${dirs[@]}"
2796 fi 2923 fi
2797 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then 2924 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then
2800 done 2927 done
2801 for file in "${evaluated_files[@]}"; do 2928 for file in "${evaluated_files[@]}"; do
2802 eval "files+=(\"\${root}${file}\")" 2929 eval "files+=(\"\${root}${file}\")"
2803 done 2930 done
2804 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m py_compile "${files[@]}" 2>&1)" || return_code="1" 2931 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m py_compile "${files[@]}" 2>&1)" || return_code="1"
2805 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2932 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2806 "$(PYTHON)" -O -m py_compile "${files[@]}" &> /dev/null || return_code="1" 2933 "$(PYTHON)" -O -m py_compile "${files[@]}" &> /dev/null || return_code="1"
2807 fi 2934 fi
2808 _python_clean_compiled_modules "${files[@]}" 2935 _python_clean_compiled_modules "${files[@]}"
2809 fi 2936 fi
2810 eend "${return_code}" 2937 eend "${return_code}"
2831 return_code="0" 2958 return_code="0"
2832 stderr="" 2959 stderr=""
2833 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation_and_version)" 2960 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation_and_version)"
2834 if ((${#other_dirs[@]})); then 2961 if ((${#other_dirs[@]})); then
2835 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m compileall "${options[@]}" "${other_dirs[@]}" 2>&1)" || return_code="1" 2962 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m compileall "${options[@]}" "${other_dirs[@]}" 2>&1)" || return_code="1"
2836 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2963 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2837 "$(PYTHON ${PYTHON_ABI})" -O -m compileall "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1" 2964 "$(PYTHON ${PYTHON_ABI})" -O -m compileall "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1"
2838 fi 2965 fi
2839 _python_clean_compiled_modules "${other_dirs[@]}" 2966 _python_clean_compiled_modules "${other_dirs[@]}"
2840 fi 2967 fi
2841 if ((${#other_files[@]})); then 2968 if ((${#other_files[@]})); then
2842 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m py_compile "${other_files[@]}" 2>&1)" || return_code="1" 2969 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m py_compile "${other_files[@]}" 2>&1)" || return_code="1"
2843 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2970 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2844 "$(PYTHON ${PYTHON_ABI})" -O -m py_compile "${other_files[@]}" &> /dev/null || return_code="1" 2971 "$(PYTHON ${PYTHON_ABI})" -O -m py_compile "${other_files[@]}" &> /dev/null || return_code="1"
2845 fi 2972 fi
2846 _python_clean_compiled_modules "${other_files[@]}" 2973 _python_clean_compiled_modules "${other_files[@]}"
2847 fi 2974 fi
2848 eend "${return_code}" 2975 eend "${return_code}"
3035} 3162}
3036 3163
3037# ================================================================================================ 3164# ================================================================================================
3038# ===================================== DEPRECATED FUNCTIONS ===================================== 3165# ===================================== DEPRECATED FUNCTIONS =====================================
3039# ================================================================================================ 3166# ================================================================================================
3167
3168fi # _PYTHON_ECLASS_INHERITED

Legend:
Removed from v.1.128  
changed lines
  Added in v.1.150

  ViewVC Help
Powered by ViewVC 1.1.20